package com.izouma.wenlvju.web;
import com.izouma.wenlvju.domain.Performance;
import com.izouma.wenlvju.service.PerformanceService;
import com.izouma.wenlvju.dto.PageQuery;
import com.izouma.wenlvju.exception.BusinessException;
import com.izouma.wenlvju.repo.PerformanceRepo;
import com.izouma.wenlvju.utils.ObjUtils;
import com.izouma.wenlvju.utils.excel.ExcelUtils;
import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/performance")
@AllArgsConstructor
public class PerformanceController extends BaseController {
    private PerformanceService performanceService;
    private PerformanceRepo performanceRepo;

    @PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public Performance save(@RequestBody Performance record) {
        if (record.getId() != null) {
            Performance orig = performanceRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return performanceRepo.save(orig);
        }
        return performanceRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<Performance> all(@RequestBody PageQuery pageQuery) {
        return performanceService.all(pageQuery);
    }

    @GetMapping("/get/{id}")
    public Performance get(@PathVariable Long id) {
        return performanceRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        performanceRepo.softDelete(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<Performance> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

